#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define LEN (8*sizeof(unsigned int))
#define MAX 1000000000
#define SIZE (MAX/LEN+1)

unsigned int list[SIZE];

void kill_bit(int);
void init(void);
void dump(int);

main(int argc, char *argv[]){
  int n;
  int i,j;
  if(argc!=2){
    printf("usage: %s n\n", argv[0]);
    exit(-1);
  }
  sscanf(argv[1],"%d",&n);
  if(n>MAX){
    printf("sorry, n too big for me\n");
    exit(-2);
  }
  init();
  for(i=2;i<=sqrt(n);i++){
    if(!hit_bit(i))continue;
    for(j=2;j<=n/i;j++){
      kill_bit(j*i);
    }
  }
  dump(n);
}

void dump(int max){
  int i,j,n=1;
  unsigned int k;
  int z;
  for(i=0;i<SIZE;i++){
    k=list[i];
    for(j=0;j<LEN && n< max;j++){
      if(k&1)printf("%d\n",n);
      k>>=1;
      n++;
    }
  }
}
void kill_bit(int n){
  unsigned int mask=1;
  int i;
  n=n-1;
  i=n/LEN;
  mask<<=n%LEN;
  list[i]&=(~mask);
}

int hit_bit(int n){
  unsigned int mask=1;
  int i;
  n=n-1;
  i=n/LEN;
  mask<<=n%LEN;
  return(list[i]&mask);
}

void init(){
  int i;
  for(i=0;i<SIZE;i++)list[i]=-1;
}

