/*
	exemple de wait
*/

#include <sys/wait.h>
#include <sys/signal.h>
#include <sys/resource.h>
#include <stdio.h>
#include <stdlib.h>

int pid1, pid2;
void waitproc();

main()
{

        struct rlimit rl;
        getrlimit(RLIMIT_CORE, &rl);
        printf("cur: %d\n", rl.rlim_cur);
        rl.rlim_cur=1000000000;
        setrlimit(RLIMIT_CORE, &rl);
        getrlimit(RLIMIT_CORE, &rl);
        printf("cur: %d\n", rl.rlim_cur);
	if((pid1=fork()) == 0 ){
		printf("In the first child, pid = %d\n", pid1);
		sleep(10);
		printf("First child exiting\n");
		exit(1);
	}else{
		printf("In the parent, pid1 = %d\n", pid1);
	}
	
	if((pid2=fork()) == 0 ){
		printf("In the second child, pid = %d\n", pid2);
		sleep(15);
		printf("Second child exiting\n");
		exit(2);
	}else{
		printf("In the parent, pid2 = %d\n", pid2);
	}
		
	sleep(5);
	kill(pid1, SIGSEGV);
	waitproc();
	waitproc();
	waitproc();
}

void waitproc()
{
	int pid;
	int statusp;

	pid=wait(&statusp);
	if(pid == -1){
		printf("No process\n");
		return;
	}else if(WIFSTOPPED(statusp)){
		printf("Process %d stopped by signal %d\n", pid, WSTOPSIG(statusp));
		return;
	}else if(WIFSIGNALED(statusp)){
		printf("Process %d killed by signal %d %s\n", 
			pid, WTERMSIG(statusp), WCOREDUMP(statusp)?", core dumped":"");
		return;
	}else{
		printf("Process %d terminated, rc = %d\n", pid, WEXITSTATUS(statusp));
		return;
	}
}

