/*
	Exemple de wait3 avec un process stoppe
*/

#include <sys/wait.h>
#include <sys/time.h>
#include <sys/signal.h>
#include <sys/resource.h>
#include <stdio.h>
#include <stdlib.h>

int pid1, pid2;
void loop(long int num);
void waitproc(int option);
void printusage(struct rusage *rusage);

main(int argc, char *argv[])
{	
	long int count;
	
	if(argc ==2 )sscanf(argv[1], "%d", &count); else count=200000;
	  
	if((pid1=fork()) == 0 ){
		printf("In the first child, pid = %d\n", pid1);
		loop(2*count);
		printf("First child exiting\n");
		exit(1);
	}else{
		printf("In the parent, pid1 = %d\n", pid1);
	}
	if((pid2=fork()) == 0 ){
		printf("In the second child, pid = %d\n", pid2);
		loop(3*count);
		printf("Second child exiting\n");
		exit(2);
	}else{
		printf("In the parent, pid2 = %d\n", pid2);
	}
		
	loop(count);
	kill(pid1, SIGSTOP);
	waitproc(0);
	waitproc(WUNTRACED);
	kill(pid1, SIGCONT);
	kill(pid1, SIGBUS);
	waitproc(0);
	waitproc(0);
}

void waitproc(int option)
{
	int pid;
	int statusp;
	struct rusage *rusage = (struct rusage *)malloc(sizeof(struct rusage));

	pid=wait3(&statusp, option, rusage);
        if(pid == -1){
                printf("No process\n");
                return;
        }else if(WIFSTOPPED(statusp)){
                printf("Process %d stopped by signal %d\n", pid, WSTOPSIG(statusp));
                return;
        }else if(WIFSIGNALED(statusp)){
                printf("Process %d killed by signal %d %s\n",
                        pid, WTERMSIG(statusp), WCOREDUMP(statusp)?", core dumped":"");
		printusage(rusage);
                return;
        }else{
                printf("Process %d terminated, rc = %d\n", pid, WEXITSTATUS(statusp));
		printusage(rusage);
                return;
        }
}

void printusage(struct rusage *rusage)
{
	printf("\tUser time  :  %d.%d\n", rusage->ru_utime.tv_sec, rusage->ru_utime.tv_usec);
	printf("\tSys  time  :  %d.%d\n", rusage->ru_stime.tv_sec, rusage->ru_stime.tv_usec);
	return;
}

void loop(long int num)
{
	long int i; float a;
	for(i=0; i<=num; i++)a++;
}
