#include <sys/types.h>
#include <sys/shm.h>
#include <sys/ipc.h>
#include <sys/signal.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <strings.h>

#define MAX_MACH	25
#define SHM_FILE "m"

void the_end();
void hexprint( void *, int);

struct machine{
	char 	flag;
#define LOCKED 0x01
	char 	name[10];
	int 	in_pkt;
	int	out_pkt;

};

struct machine_v{
	struct machine machine[MAX_MACH];
} *shm_mach;

int shm_id;

main()
{

	char i;

	key_t	shm_key;

	signal(SIGINT, the_end);

	if((shm_key = ftok(SHM_FILE, '\x01')) <0){
		perror("ftok");
		exit(-1);
	}

	printf("key: %x\n", shm_key);

	if((shm_id = shmget( shm_key, sizeof(struct machine_v), IPC_CREAT|SHM_W|SHM_R)) <0){
		perror("shmget");
		exit(-1);
	}

	printf("shmget: %d\n", shm_id);

	if((shm_mach = (struct machine_v *)shmat(shm_id, 0, 0)) <0){
		perror("shmat");
		exit(-1);
	}

	
	printf("shm_mach: 0x%x\n", shm_mach);

	for(;;){
/*
                printf("writing...");
*/
		for(i=0; i<MAX_MACH; i++){
			
			(shm_mach->machine[i]).flag=LOCKED;
                        sprintf((shm_mach->machine[i]).name,"ccpnba%d",i);
			(shm_mach->machine[i]).in_pkt = rand();
			(shm_mach->machine[i]).out_pkt=rand();
			(shm_mach->machine[i]).flag &= ~LOCKED;
		}
/*
                printf("done\n");
*/

/*		sleep(1);  */
	}

}

void the_end()

{	

	char i;
	struct shmid_ds *shm_ds;

	printf("terminated by SIGINT,detaching segment at:0x%x\n",shm_mach);
/*	
	if(shmctl(shm_id, IPC_RMID, shm_ds) <0){
		perror("shmctl");
		exit(-1);
	}
*/
	if(shmdt(shm_mach) <0){
		perror("shmdt");
		exit(-1);
	}

	exit(0);
}
