/*
	Simple data-base server on Unix domain socket
*/

#include "whoisd.h"

/*
short data-base...
*/

#define DATASIZE 7
char *data[]={"lundi",
	      "mardi",
	      "mercredi",
	      "jeudi",
	      "vendredi",
	      "samedi",
	      "dimanche"
};

main()
{
	int	sock, newsock;
        socklen_t  cli_addrlen, serv_addrlen;
	struct sockaddr_un	cli_addr, serv_addr;
	char c;
	
	/*
	establish a listen socket on Unix domain
	*/
	
	if( (sock = socket(AF_UNIX, SOCK_STREAM, 0)) <0){
		perror("socket:");
		exit(1);
	}
	
	unlink(DB_SOCKET);
	
	bzero((char *) &serv_addr, sizeof(serv_addr));
	serv_addr.sun_family = AF_UNIX;
	strcpy(serv_addr.sun_path, DB_SOCKET);
	serv_addrlen = strlen(serv_addr.sun_path) + sizeof(serv_addr);
	
	if(bind(sock, (struct sockaddr *) &serv_addr, serv_addrlen) <0){
		perror("bind:");
		exit(1);
	}
	
	listen(sock, 5);
	
	/*
	loop on connections. DON'T FORK, BLOCK!
	*/
	
	for(;;){
		
		int n, index, i;
		char line[MAXLINE];
		
		/* cli_addrlen = sizeof(cli_addr);  */
		if((newsock = accept(sock, (struct sockaddr *) &cli_addr, &cli_addrlen)) <0){
			perror("accept:");
			exit(1);
		}
		printf("connected\n");fflush(stdout);
		
		/*
		loop on questions and answer each
		*/
		
		for(;;){
		
			n=readline(newsock, line, MAXLINE);
			if(n ==0)break;
			if(n <0){
				perror("str_echo: readline:");
				exit(1);
			}
			printf("received: %s", line);fflush(stdout);
			
			/*
			analyze question. If reasonnable, give answer, ening with <NL>
			*/
			
			sscanf(line, "%i", &index);
			if(index >= 0 && index < DATASIZE){
				for(i=0; i<=index; i++){
					sprintf(line, "%s\n", data[i]);
					n=strlen(line);
					if(writen(newsock, line, n) !=n){
						perror("str_echo: writen:");
						exit(1);
					}
				}
			}else{
				sprintf(line, "out of range\n");
				n=strlen(line);
				if(writen(newsock, line, n) !=n){
					perror("str_echo: writen:");
					exit(1);
				}
			}
			if(writen(newsock, "\n", 2) !=2){
				perror("str_echo: writen:");
				exit(1);
			}
		}
		
		/*
		fall here if readline give 0: client exit. wait for another
		*/
		
		printf("closed\n");fflush(stdout);
		
		close(newsock);
	}
}
