#include "whoisd.h"

int readn(int fd, char *ptr, int nbytes)
{
	int nleft, nread;
	
	nleft = nbytes;
	while(nleft >0){
		nread = read(fd, ptr, nleft);
		if(nread <0)
			return(nread);
		else if(nread ==0)
			break;
		
		nleft -=nread;
		ptr   +=nread;
	}
	return(nbytes-nleft);
}

int writen(int fd, char *ptr, int nbytes)
{
	int nleft, nwritten;
	
	nleft=nbytes;
	while(nleft >0){
		nwritten = write(fd, ptr, nleft);
		if(nwritten <=0)
			return(nwritten);
			
		nleft -=nwritten;
		ptr   +=nwritten;
	}
	return(nbytes-nleft);
}

int readline(int fd, char *ptr, int maxlen)
{
	int n, rc;
	char c;
	
	for(n=1; n < maxlen; n++){
		if((rc=read(fd, &c, 1)) ==1){
			*ptr++ = c;
			if(c == '\n')
				break;
		}else if (rc ==0){
			if(n ==1)
				return(0);
			else
				break;
		}else
			return(-1);
	}
	
	*ptr=0;
	return(n);
}

void str_echo(int sock)
{
	int n;
	char line[MAXLINE];
	
	for(;;){
		n=readline(sock, line, MAXLINE);
		if(n ==0)
			return;
		else if(n <0)
			perror("str_echo: readline:");
		printf("received: %s", line);
		if(writen(sock, line, n) !=n)
			perror("str_echo: writen:");
	}
}

void str_cli(FILE *fp, int sock)
{
	int n;
	char sendline[MAXLINE], recvline[MAXLINE +1];
	
	while(fgets(sendline, MAXLINE, fp) != NULL){
		n=strlen(sendline);
		if(writen(sock, sendline, n) != n)
			perror("str_cli: written:");
		n=readline(sock, recvline, MAXLINE);
		if(n <0)
			perror("str_cli: readline:");
		recvline[n]=0;
		fputs(recvline, stdout);
	}
	
	if(ferror(fp))
		perror("str_cli: fgets:");
}
			
