/*
	Relay application between whois requests and database server
*/

#include "whoisd.h"

main()
{
	int	whoisd_sock, whois_sock, db_sock;
        socklen_t whoisd_addrlen, whois_addrlen, db_addrlen;
	struct sockaddr_in	whois_addr;
	struct sockaddr_in	whoisd_addr;
	struct sockaddr_un	db_addr;
	int childpid;
	
	/* 
	establish a listen socket on whois port 
	*/
	
	if( (whoisd_sock = socket(AF_INET, SOCK_STREAM, 0)) <0){
		perror("whoisd: socket");
		exit(1);
	}
	
	bzero((char *) &whoisd_addr, sizeof(whoisd_addr));
	whoisd_addr.sin_family 		=AF_INET;
	whoisd_addr.sin_addr.s_addr	=htonl(INADDR_ANY);
	whoisd_addr.sin_port		=htons(WHOIS_PORT);
	
	if(bind(whoisd_sock, (struct sockaddr *)&whoisd_addr, sizeof(whoisd_addr)) <0){
		perror("whoisd: bind");
		exit(1);
	}
	
	listen(whoisd_sock, 5);
	
	/*
	accept incomming connections, forking a child to handle each
	*/
	
	for(;;){
	
		char *whois_asc_addr;
		u_short whois_port;
		
		whois_addrlen=sizeof(whois_addr);
		whois_sock=accept(whoisd_sock, (struct sockaddr *)&whois_addr, &whois_addrlen);
		
		if(whois_sock <0){
			perror("whoisd: accept");
			exit(1);
		}
		
		whois_asc_addr=inet_ntoa(whois_addr.sin_addr);
		whois_port=whois_addr.sin_port;
		printf("connected from: %s, port: %i\n", whois_asc_addr, whois_port);
		
		/*
		put an annonce
		*/
		
		writen(whois_sock, "Welcome!\n", 10);
		writen(whois_sock, "Give a number n between 0 and 6\n", 33);
		writen(whois_sock, "you will get a list of week day between 0 and n!\n", 50);
		
		if((childpid = fork()) <0){
			perror("whoisd: fork");
			exit(1);
		}else if(childpid ==0){		
		
			/* 
			in the child: contact data-base server on Unix socket
			*/
			
			close(whoisd_sock);
			
			if((db_sock = socket(AF_UNIX, SOCK_STREAM, 0)) <0){
				perror("whoisd: unix_socket:");
				exit(1);
			}
	
			bzero((char *) &db_addr, sizeof(db_addr));
			db_addr.sun_family = AF_UNIX;
			strcpy(db_addr.sun_path, DB_SOCKET);
			db_addrlen = sizeof(db_addr);
	
			if(connect(db_sock, (struct sockaddr *) &db_addr, db_addrlen) <0){
				perror("whoisd: unix_connect:");
				exit(1);
			}
	
			/*
			loop reading questions on whois socket 
			*/
			
			for(;;){
				int n;
				char line[MAXLINE];
				
				n=readline(whois_sock, line, MAXLINE);
				if(n ==0)break;
				if(n <=0){
					perror("whoisd: readline");
					exit(1);
				}
				printf("received from %s, port %i: %s",
					whois_asc_addr, whois_port, line);fflush(stdout);
					
				/*
				transmit each question to the data-base server
				*/			
						
				if(writen(db_sock, line, n) !=n){
					perror("woisd: unix_writen");
				}
				
				/*
				loop on answers, transmit to client, end on <NL>
				*/
				
				writen(whois_sock, "answer:\n", 9);
				
				for(;;){
					n=readline(db_sock, line, MAXLINE);
					if(!strcmp(line, "\n"))break;
					if(n <0){
						perror("whoisd: unix_readline");
						exit(1);
					}
					printf("received from unix: %s", line);fflush(stdout);
				
					if(writen(whois_sock, line, n) !=n){
						perror("woisd: writen");
					}
				}
			}
			
			/*
			fall here if readline give 0: client exit. Do the same...
			*/
			
			printf("closed from: %s, port: %i\n", whois_asc_addr, whois_port);
			close(db_sock);
				
			exit(0);
		}
		
		/*
		in the parrent: clear old socket and redo
		*/
		
		close(whois_sock);
	}
		
}
