#include <stdio.h>
#include <string.h>
#include <stdlib.h>

struct entry {
  char name[40];
  char phone[40];
  struct entry *next;
};

struct entry *sl_insert( struct entry *, struct entry * );
struct entry *sl_delete( char *, struct entry * );
void sl_search( char *, struct entry * );
void display( struct entry * );

int main(){
  struct entry *first=NULL;
  struct entry *work;
  char c[40], name[40], phone[40];

  while(1){
  printf("? ");
  scanf("%s", c);
  switch(c[0]){
    case 'l':
      display(first);
      break;
    case 'i':
      printf("name: ");
      scanf("%s", name);
      printf("phone: ");
      scanf("%s", phone);
      work = (struct entry *) malloc(sizeof(struct entry));
      strcpy(work->name, name);
      strcpy(work->phone, phone);
      first = sl_insert( work, first);
      break;
    case 'd':
      printf("name: ");
      scanf("%s", name);
      first = sl_delete( name, first );
      break;
    case 's':
      printf("name: ");
      scanf("%s", name);
      sl_search( name, first );
      break;
    case 'q':
      exit(0);
      break;
    default:
      printf("unknown comand\n");
      break;
    }
  }
}

struct entry *sl_insert( struct entry *i, struct entry *first ){
  struct entry *old, *current;
  if(!first){
    i->next = NULL;
    return i;
  }
  old=NULL;
  current=first;
  while(current){
    if(strcmp(current->name,i->name) <0 ){
      old=current;
      current = current->next;
    } else {
      if(!old){
        i->next=first;
        return i;
      } else {
        old->next=i;
        i->next=current;
        return first;
      }
    }
  }
  old->next=i;
  i->next=NULL;
  return first;
}

struct entry *sl_delete( char *name, struct entry *first ){
  struct entry *old, *current;
  old=NULL;
  current=first;
  while(current){
    if(strcmp(current->name,name) !=0 ){
      old=current;
      current = current->next;
    } else {
      if(!old){
        return current->next;
      } else {
        old->next=current->next;
        return first;
      }
    }
  }
  printf("not found\n");
  return first;
}

void sl_search( char *name, struct entry *first ){
  while(first){
    if(strcmp(first->name, name) == 0){
      printf("%s\n", first->phone);
      return;
    }
    first=first->next;
  }
  printf("not found\n");
}

void display( struct entry *first ){
  while(first){
    printf("%s\n", first->name);
    first=first->next;
  }
}
