#include <stdio.h>
#include <strings.h>
#include <stdlib.h>
 
void read_grid(FILE *);
void print_one(void);
int try( int, int, char);
void solve(int, int);

char grid[9][9];

int main(int argc, char *argv[]){

  FILE *f;

  if( argc != 2) {
    printf("usage: %s file\n", argv[0]);
    exit(-1);
  }

  if( ( f = fopen( argv[1], "r") ) == NULL ) {
    printf("unable to open %s\n", argv[1]);
    exit( -1 );
  }

  read_grid( f);
  solve(0,0);
}

void read_grid( FILE *f){

  int l,c;
  char line[10];

  for(l=0; l<9;l++){
    fscanf(f, "%s", line);
    if(strlen(line) !=9 ){
      printf("syntax error in %s, line %d\n", f, l);
      exit( -1 );
    }
    for(c=0; c<9; c++){
      grid[l][c]=line[c];
    }
  }
}

void print_one(void){

  static int nsol = 0;
  int l, c;

  printf("solution %d \n", ++nsol);
  for (l = 0; l < 9; l++) {
    for (c = 0; c < 9; c++){
      printf("%c", grid[l][c]);
    }
    printf("\n");
  }
}

int try(int i, int j, char n){

  int l, c, bl, bc;

  if (grid[i][j] == n) return(1);
  if (grid[i][j] != '-') return(0);
  for (c = 0; c < 9; c++){ 
    if (grid[i][c] == n) return(0);
  }
  for (l = 0; l < 9; l++){ 
    if (grid[l][j] == n) return(0);
  }
  bl = i / 3;
  bc = j / 3;
  for (l = bl * 3; l < (bl + 1) * 3; l++){
    for (c = bc * 3; c < (bc + 1) * 3; c++){
      if (grid[l][c] == n) return(0);
    }
  }
  return(1);
}
 
void solve(int l, int c){

  char n, t;
 
  if (l == 9){
    print_one();
  }else{
    for (n = '1'; n <= '9'; n++){
      if (try(l, c, n)) {
	t = grid[l][c];
	grid[l][c] = n;
        if (c == 8){
          solve(l + 1, 0);
        }else{
          solve(l, c + 1);
        }
        grid[l][c] = t;
      }
    }
  }
}
 
